services:
  - docker:dind

include:
  - template: Code-Quality.gitlab-ci.yml

cache:
  key: "$CI_BUILD_REF_NAME"
  paths:
    - .m2/repository

variables:
  MAVEN_OPTS: "-Djava.awt.headless=true -Dmaven.repo.local=.m2/repository"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version"
  
stages:
  - build
  - test
  - package
  - aceite
  - producao

compilacao:
  image: maven:3.3.9
  stage: build
  script:
    - mvn clean install
  artifacts:
    when: always
    paths:
     - ${CI_PROJECT_DIR}/target/${CI_PROJECT_NAME}.war

sonar-report:
  image: maven:3.3.9
  stage: test
  variables:
    SONAR_HOST_URL: ${SONAR_HOST_URL}
    SONAR_TOKEN: ${SONAR_TOKEN} 
    GIT_DEPTH: 0
  script:    
    - mvn verify sonar:sonar -Dsonar.qualitygate.wait=true -Dsonar.host.url="${SONAR_HOST_URL}" -Dsonar.token="${SONAR_TOKEN}" -Dsonar.organization="${SONAR_ORGANIZATION}"
  allow_failure: true
  only:
   - master

docker-build:
  image: docker:latest
  stage: package
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - cp "$CI_PROJECT_DIR"/target/"$CI_PROJECT_NAME".war .
    - cp "$CI_PROJECT_DIR"/ambiente/wildfly/Dockerfile .
    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
    - docker push "$CI_REGISTRY_IMAGE"    
  dependencies:
    - compilacao
  only:
    - master

deploy-aceite:
  image: docker:latest
  stage: aceite
  environment:
    name: aceite
  script:
    - echo "Job para publicação no ambiente de aceite..."
  only:
    - master
    
deploy-producao:
  image: docker:latest
  stage: producao
  environment:
    name: producao
  script:
    - echo "Job para publicação no ambiente de produção..."
  when: manual
